-- Author      : Nogarder
-- Create Date : 2015/3/1 23:34:00

RS.RegisterPageFunc("SequenceEditor",function()
	local table_remove=table.remove

	local Localization=RS.Localization
	local Tooltips=Localization.Tooltips

	local parent=RS.OptionsMain
	
	local main=RS.Template.CreatePriorityEdit(parent,nil,300,400,50,nil,nil)
	main:Hide()
	--
	local page=main.Frame
	local scroll=main.Scroll
	--
	local Entry={}
	local EntryName=nil
	--
	local Refresh=function()
		RS.Template.UpdatePriorityEdit(scroll,Entry)
	end
	--
	page.ButtonCreateFunc=function(button)
		button.Label=RS.Template.CreateText(button)
		button.Label:SetPoint("LEFT",button,"LEFT",10,0)

		button.GroupFrame=RS.Template.CreatePlayerGroup(button)
		button.GroupFrame:SetPoint("TOPLEFT",button,"TOPLEFT",20,0)
		button.GroupFrame:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT",-10,0)

		button:HookScript("OnMouseUp",function(self)
			RS.SetPage("GroupEditor",main,Entry,self,function()
					RS.Template.SetPlayerGroup(button.GroupFrame,Entry[self.EntryIndex],true)
				end)
		end)
	end
	--
	page.ButtonUpdateFunc=function(button,index)
		button.Label:SetText(index)
		--
		RS.Template.SetPlayerGroup(button.GroupFrame,Entry[index],true)
	end
	--
	page.LoadFunc=function()
		if(EntryName)then
			Entry=CopyTable(RS_Profile[EntryName])
		else
			Entry={}
		end
		Refresh()
	end
	--
	page.SaveFunc=function(matchtable)
		local entry={}
		for index,index2 in pairs(matchtable)do
			entry[index]=CopyTable(Entry[index2])
		end
		
		RS_Profile[EntryName]=entry
		Entry=CopyTable(entry)
		Refresh()
		--fire update event
		RS.EventHandler.FireEvent(1,"RS_SettingUpdated")
	end
	--
	page.OnCopyFunc=function(oldindex,newindex)
		Entry[newindex]=CopyTable(Entry[oldindex])
		Refresh()
	end
	page.OnDeleteFunc=function(oldindex)
		table_remove(Entry,oldindex)
		Refresh()
	end
	page.OnRenameFunc=function(oldindex,newindex)
		Entry[newindex]=CopyTable(Entry[oldindex])
		table_remove(Entry,oldindex)
		Refresh()
	end
	page.OnCreateFunc=function(newindex)
		Entry[newindex]={}
		Refresh()
	end
	--
	main.OnSetFunc=function(entryname)
		EntryName=entryname
		page.LoadFunc()
	end
	--
	RS.RegisterPage("SequenceEditor",main)

end)