﻿-- Author      : Nogarder
-- Create Date : 2014/12/1 3:25:53
--scroll frame uses slider and liner
--main
RS.ScrollFrame={}
--list
local RS_ScrollFrame_List={}
--update
RS.Template.UpdateScrollFrame=function(frame)
	local scroll=frame.Scroll
	local scrollwidth=scroll:GetWidth()
	local scrollheight=scroll:GetHeight()
	local framewidth=frame:GetWidth()
	local frameheight=frame:GetHeight()
	--if(framewidth<scrollwidth)then
	--	frame:SetWidth(scrollwidth)
	--elseif(frameheight<scrollheight)then
	--	frame:SetHeight(scrollheight)
	--end
	local xrange=framewidth-scrollwidth
	local yrange=frameheight-scrollheight
	if(xrange<1)then
		RS.Template.SetSlider(scroll.SliderX,1,1,1)
		scroll.SliderX:Hide()
	else
		RS.Template.SetSlider(scroll.SliderX,nil,nil,xrange)
		scroll.SliderX:Show()
	end
	if(yrange<1)then
		RS.Template.SetSlider(scroll.SliderY,1,1,1)
		scroll.SliderY:Hide()
	else
		RS.Template.SetSlider(scroll.SliderY,nil,nil,yrange)
		scroll.SliderY:Show()
	end
end
--set scroll
RS.Template.CreateScrollFrame=function(parent,width,height,noborder,nobackground,reversscrolly)
	local scroll=CreateFrame("ScrollFrame",nil,parent)
	scroll:EnableMouse(true)
	scroll:SetPoint("CENTER",UIParent,"CENTER")

	if(not noborder)then
		RS.Template.CreateBorder(scroll)
	end
	--set mouse wheel
	scroll:EnableMouseWheel(1)
	scroll:SetScript("OnMouseWheel",function(self,value)
		local slidery=self.SliderY
		if(slidery and slidery:IsShown())then
			local value=slidery.Value - floor(value *RS.ScrollSpeed)
			RS.Template.SetSlider(slidery,value)
		end
	end)
	--
	scroll:SetWidth(width)
	scroll:SetHeight(height)
	scroll:SetVerticalScroll(0)
	scroll:SetHorizontalScroll(0)
	--scroll child
	local frame=CreateFrame("Frame",nil,scroll)
	if(not nobackground)then
		RS.Template.CreateBackground(frame,nil,0.3,0.8)
	end
	scroll:SetScrollChild(frame)
	frame:SetHeight(1)
	frame:SetWidth(1)
	frame:EnableMouse(true)
	frame:SetPoint("TOPLEFT",scroll,"TOPLEFT",1,-1)
	--slider
	scroll.SliderX=RS.Template.CreateSlider(scroll,0,1,1,0,1,function(self)
		self:GetParent():SetHorizontalScroll(self.Value)
		end,
		true)
	scroll.SliderX:SetPoint("TOPLEFT",scroll,"BOTTOMLEFT",0,0)
	scroll.SliderX:SetPoint("TOPRIGHT",scroll,"BOTTOMRIGHT",0,0)
	scroll.SliderX:SetHeight(20)
	--
	scroll.SliderY=RS.Template.CreateSlider(scroll,0,1,1,0,3,function(self)
		self:GetParent():SetVerticalScroll(self.Value)
		end,
		true)
	if(reversscrolly)then
		scroll.SliderY:SetPoint("TOPRIGHT",scroll,"TOPLEFT",0,0)
		scroll.SliderY:SetPoint("BOTTOMRIGHT",scroll,"BOTTOMLEFT",0,0)
	else
		scroll.SliderY:SetPoint("TOPLEFT",scroll,"TOPRIGHT",0,0)
		scroll.SliderY:SetPoint("BOTTOMLEFT",scroll,"BOTTOMRIGHT",0,0)
	end
	scroll.SliderY:SetWidth(20)
	--
	scroll.SliderX:SetFrameLevel(frame:GetFrameLevel()+3)
	scroll.SliderY:SetFrameLevel(frame:GetFrameLevel()+3)
	--show
	frame.Scroll=scroll
	scroll.Frame=frame
	frame:Show()
	scroll:Show()
	--update once
	RS.Template.UpdateScrollFrame(frame)
	--return pointer
	return frame
end
