﻿-- Author      : Nogarder
-- Create Date : 2012/4/11 14:54:21
-- Author      : Nogarder
-- Create Date : 2012/4/11 14:54:21
local Localization=RS.Localization
local Tooltips=Localization.Tooltips
--
RS.Template.CreateSystemButton=function(parent,width,height,text)
	local button=CreateFrame("Button",nil,parent)
	button:SetHeight(15)
	button:SetWidth(width)
	--label
	button.Label=button:CreateFontString(nil,"OVERLAY")
	button.Label:SetFont(RS.TextFont,10,RS.TextMode)
	button.Label:SetPoint("TOPLEFT",button,"TOPLEFT",0,0)
	button.Label:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT",0,0)
	button.Label:SetText(text)
	button:EnableMouse(true)
	--background
	button.Background=RS.Template.CreateBackground(button)
	--script
	RS.Template.SetAutoFocus(button)
	--
	return button
end
--create
RS.Template.CreateButton=function(parent,width,height,text)
	local button=CreateFrame("Frame",nil,parent)
	--background
	button.Background=RS.Template.CreateBackground(button)
	--script
	RS.Template.SetAutoFocus(button)
	--
	height=height or 10
	--label
	button.Label=button:CreateFontString(nil,"OVERLAY")
	button.Label:SetFont(RS.TextFont,height-2,RS.TextMode)
	button.Label:SetPoint("CENTER",button,"CENTER",0,0)
	button.Label:SetText(text)
	button:EnableMouse(true)
	button.Texture=button:CreateTexture(nil,"ARTWORK")
	button.Texture:SetPoint("TOPLEFT",button,"TOPLEFT")
	button.Texture:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT")
	--
	button:SetHeight(height)

	if(not text)then
		text=" "
	end
	if(not width)then
		if(text)then
			width=button.Label:GetWidth()+4
		else
			width=10
		end
	end
	button:SetWidth(width)
	--show
	button:Show()
	--return pointer
	return button
end
--macro for disable button
RS.Template.DisableButton=function(button)
	if(not button.DisableLiner)then
		local texture=button:CreateTexture(nil,"OVERLAY")
		texture:SetPoint("LEFT",button,"LEFT",0,0)
		texture:SetPoint("RIGHT",button,"RIGHT",0,0)
		texture:SetHeight(button:GetHeight()/5)
		texture:SetTexture("Interface\\Addons\\NPA2_Options\\texture\\Liner")
		texture:Show()
		button.DisableLiner=texture
	else
		button.DisableLiner:Show()
	end
	button.Disabled=true
	button:EnableMouse(false)
end
--macro for enable button
RS.Template.EnableButton=function(button)
	if(button.DisableLiner)then
		button.DisableLiner:Hide()
	end
	button.Disabled=nil
	button:EnableMouse(true)
end
--macro for set preview
RS.Template.SetButtonPreview=function(button,unit)
	if(not unit)then
		RS.SetTextFont(button.Label)
		RS.SetTexture(button.Texture)
		button:SetWidth(button.Label:GetWidth()+10)
	else
		if(unit.Disabled)then
			RS.Template.DisableButton(button)
		else
			RS.Template.EnableButton(button)
		end
		--preview
		RS.SetTextFont(button.Label,unit.Font,unit.FontProfileName)
		RS.SetTexture(button.Texture,unit.TextureProfileName,unit.TextureFile,"BLEND",{R=1,G=1,B=1,A=1},0,0,1,0,1)
		if(unit.SquareTexture)then
			button.Texture:ClearAllPoints()
			button.Texture:SetPoint("TOPLEFT",button,"TOPLEFT")
			button.Texture:SetPoint("BOTTOMLEFT",button,"BOTTOMLEFT")
			button.Texture:SetWidth(button:GetHeight())
			button.Label:ClearAllPoints()
			button.Label:SetPoint("LEFT",button.Texture,"RIGHT",0,0)
			button:SetWidth(button:GetHeight()+button.Label:GetWidth()+10)
		else
			button.Texture:ClearAllPoints()
			button.Texture:SetPoint("TOPLEFT",button,"TOPLEFT")
			button.Texture:SetPoint("BOTTOMRIGHT",button,"BOTTOMRIGHT")
			button.Label:ClearAllPoints()
			button.Label:SetPoint("CENTER",button,"CENTER",0,0)
			button:SetWidth(button.Label:GetWidth()+10)
		end
		if(unit.Color)then
			local color=unit.Color
			button.Label:SetTextColor(color.R,color.G,color.B,color.A)
			button.Texture:SetVertexColor(color.R,color.G,color.B,color.A)
		end
	end
end
--macro for special button
RS.Template.CreateSpecialButton=function(parent,width,height,btype)
	local button=RS.Template.CreateButton(parent,width,height,Localization[btype])
	RS.Template.SetTooltips(Tooltips[btype],button)
	return button
end
-----------------
--colorbutton--
-----------------
do
	RS.Template.SetColorButton=function(button,color)
		button.Value=CopyTable(color)
		button.Texture:SetTexture(color.R,color.G,color.B,color.A)
	end
	--
	local ColorButtonOnClick=function(self)
		RS.SetPage("ColorPicker",self.LinkTo,self.Value.R,self.Value.G,self.Value.B,self.Value.A,function(r,g,b,a)
			self.Value.R=r
			self.Value.G=g
			self.Value.B=b
			self.Value.A=a
			self.Texture:SetTexture(r,g,b,a)
			RS.RunFunc(self.OnValueUpdateFunc,self)
		end)
	end
	--
	local ColorChangeButtonOnClick=function(self)
		ColorButtonOnClick(self:GetParent())
	end
	--
	RS.Template.CreateColorButton=function(parent,width,height,label,linkto,tooltip,callbackfunc)
		local frame=CreateFrame("Frame",nil,parent)
		frame:SetWidth(width)
		frame:SetHeight(height)
		frame:EnableMouse(true)
		RS.Template.SetAutoFocus(frame)
		--
		frame.LinkTo=linkto
		--
		frame:HookScript("OnMouseUp",ColorButtonOnClick)
		--
		local button=RS.Template.CreateButton(frame,40,20,Localization["Change"])
		button:SetPoint("RIGHT",frame,"RIGHT",0,0)
		button:HookScript("OnMouseUp",ColorChangeButtonOnClick)
		button:HookScript("OnHide",function()
			NPA.TextureManager.RemoveAnimatedTexture(button.Texture)--just in case, release resources
		end)
		--
		frame.Button=button
		--
		local texture=frame:CreateTexture(nil,"ARTWORK")
		texture:SetPoint("LEFT",frame,"LEFT",0,0)
		texture:SetPoint("RIGHT",button,"LEFT",-2,0)
		texture:SetHeight(height)
		frame.Texture=texture
		--
		local texturebg=frame:CreateTexture(nil,"BACKGROUND")
		texturebg:SetPoint("TOPLEFT",texture,"TOPLEFT")
		texturebg:SetPoint("BOTTOMRIGHT",texture,"BOTTOMRIGHT")
		texturebg:SetTexture(0,0,0,1)
		--
		local label=RS.Template.CreateText(frame,label,true)
		label:SetPoint("BOTTOM",texture,"TOP",0,2)
		--
		RS.Template.SetTooltips(tooltip,frame)
		--
		return frame
	end
	--
	RS.Template.DisableColorButton=function(frame)
		frame:EnableMouse(false)
		frame.Button:EnableMouse(false)
	end
	RS.Template.EnableColorButton=function(frame)
		frame:EnableMouse(true)
		frame.Button:EnableMouse(true)
	end
end
--------------------
------------------------
--font editor button--
------------------------
do
	local GetFontList=function()
		local list={}
		local i=0
		for name,_ in pairs(NPA_Setting.Font)do
			i=i+1
			list[i]={
				Text=name,
				Value=name,
				FontProfileName=name,
			}
		end
		return list
	end
	--
	RS.Template.CreateFontEditorButton=function(page,main,width)
		local fontselector=RS.Template.CreateDropDownEditor(page,width,Localization["Font"]..Localization["Profile"],nil,GetFontList)
		--edit button
		local fonteditbutton=RS.Template.CreateButton(fontselector,40,20,Localization["Edit"])
		fonteditbutton:SetPoint("LEFT",fontselector,"RIGHT",20,0)
		RS.Template.SetTooltips(Tooltips["Edit"],fonteditbutton)

		fonteditbutton:HookScript("OnMouseUp",function()
			RS.SetPage("FontLib",main,fontselector.Value)
		end)

		return fontselector
	end
end
-------------------------------
-------------------------------
--texture file editor button--
-------------------------------
do
	local GetTextureList=function()
		local list={}
		local i=0
		for name,_ in pairs(NPA_Setting.Texture)do
			i=i+1
			list[i]={
				Text=name,
				Value=name,
				TextureProfileName=name,
			}
		end
		for name,_ in pairs(NPA_Setting.AnimatedTexture)do
			i=i+1
			list[i]={
				Text="@"..name,
				Value="@"..name,
				TextureProfileName="@"..name
			}
		end
		return list
	end
	RS.Template.CreateTextureSelectorButton=function(page,main,width)
		local textureselector=RS.Template.CreateDropDownEditor(page,width,Localization["Texture"]..Localization["Profile"],nil,GetTextureList)
		--edit button
		local textureeditbutton=RS.Template.CreateButton(textureselector,40,20,Localization["Edit"])
		textureeditbutton:SetPoint("LEFT",textureselector,"RIGHT",20,0)
		RS.Template.SetTooltips(Tooltips["Edit"],textureeditbutton)

		textureeditbutton:HookScript("OnMouseUp",function()
			local _,name2=string.split("@",textureselector.Value)
			if(name2)then
				RS.SetPage("AnimatedTextureLib",main,name2)
			else
				RS.SetPage("TextureLib",main,textureselector.Value)
			end
		end)
		return textureselector
	end
end
-------------------------------
--texture file path list button--
-------------------------------
do
	RS.Template.CreateTextureFileSelectorButton=function(page,main,width,localization,tooltip)
		local textureselector=RS.Template.CreateDropDownEditor(page,width-40,localization,tooltip,RS.InfoLib.GetTexture,50)
		textureselector.FreeEdit=true
		--from spell button
		local textureeditbutton=RS.Template.CreateButton(textureselector,40,20,Localization["LookUp"])
		textureeditbutton:SetPoint("LEFT",textureselector,"RIGHT",22,0)
		RS.Template.SetTooltips(Tooltips["LookUp"],textureeditbutton)

		textureeditbutton:HookScript("OnMouseUp",function()
			RS.SetPage("SpellLookUp",main,"",function(spellid)
					local _, _,icon=GetSpellInfo(spellid)
					RS.Template.SetDropDownEditor(textureselector,icon)
					textureselector.OnValueUpdateFunc()
				end)
		end)
		return textureselector
	end
end
--------------------------------
--------------------------------
--numbertext editor button--
--------------------------------
do
	RS.Template.CreateNumberTextEditorButton=function(parent,width,height,title,main,colortable)
		local button=RS.Template.CreateButton(parent,width,height,title)
		button:HookScript("OnMouseUp",function()
			RS.SetPage("NumberTextEditor",main,button.Value,button.OnValueUpdateFunc,colortable)
		end)
		return button
	end
end
--------------------------------
--------------------------------
--number selector button--
--------------------------------
do
	local GetNumberList=function()
		local list={}
		local i=0
		for name,_ in pairs(NPA_Setting.Number)do
			i=i+1
			list[i]={
				Text=name,
				Value=name,
			}
		end
		return list
	end
	RS.Template.CreateNumberSelectorButton=function(page,main,width)
		local numberselector=RS.Template.CreateDropDownEditor(page,width,Localization["Number"]..Localization["Profile"],nil,GetNumberList)
		--edit button
		local editbutton=RS.Template.CreateButton(numberselector,40,20,Localization["Edit"])
		editbutton:SetPoint("LEFT",numberselector,"RIGHT",20,0)
		RS.Template.SetTooltips(Tooltips["Edit"],editbutton)

		editbutton:HookScript("OnMouseUp",function()
			RS.SetPage("NumberLib",main,numberselector.Value,numberselector.OnValueUpdateFunc)
		end)
		return numberselector
	end
end
--bar btype selector button
-------------------------------
do
	local GetBarGroupList=function()
		local list={}
		local i=0
		for name,_ in pairs(NPA_Setting.BarGroup)do
			i=i+1
			list[i]={
				Text=name,
				Value=name,
			}
		end
		return list
	end
	RS.Template.CreateBarGroupSelectorButton=function(page,main,width)
		local bargroupselector=RS.Template.CreateDropDownEditor(page,width,Localization["BarGroup"]..Localization["Profile"],nil,GetBarGroupList)
		--edit button
		local editbutton=RS.Template.CreateButton(bargroupselector,40,20,Localization["Edit"])
		editbutton:SetPoint("LEFT",bargroupselector,"RIGHT",20,0)
		RS.Template.SetTooltips(Tooltips["Edit"],editbutton)

		editbutton:HookScript("OnMouseUp",function()
			RS.SetPage("BarGroupLib",main,bargroupselector.Value,nil,nil,nil,nil,function()
				--only set preview when not on hiding or hidden
				if(RS.Animation.NotHide(main))then
					RS.SetPage("BarGroupPreview",main,bargroupselector.Value)
					page.SetPreview()
				end
			end)
		end)
		return bargroupselector
	end
end
