-- Author      : Nogarder
-- Create Date : 2014/12/1 3:18:07
local Tooltips=RS.Localization.Tooltips
--
local RS_Template_FrameWithBar_Reset=function(self)
	self.Dragged=nil
	self.Scroll:SetScale(1)
	self.ZoomSlider.Value=1
	--RS.Animation.RestoreScroll(self.Scroll)
	self:ClearAllPoints()
	if(self.LinkTo)then
		if(self.LinkType=="BOTTOMRIGHT")then
			self:SetPoint("TOPRIGHT",self.LinkTo.Scroll,"BOTTOMRIGHT",self:GetWidth(),-40)
		elseif(self.LinkType=="BOTTOMLEFT")then
			self:SetPoint("TOPLEFT",self.LinkTo.Scroll,"BOTTOMLEFT",0,-40)
		else
			if(self.LinkTo.Scroll.Revers)then
				self:SetPoint("TOPLEFT",self.LinkTo.Scroll,"TOPRIGHT",3,0)
			elseif(self.Scroll.Revers)then
				self:SetPoint("TOPRIGHT",self.LinkTo,"TOPLEFT",-10,0)
			else
				if(self.LinkTo.Scroll.SliderY:IsShown())then
					self:SetPoint("TOPLEFT",self.LinkTo.Scroll.SliderY,"TOPRIGHT",3,0)
				else
					self:SetPoint("TOPLEFT",self.LinkTo.Scroll,"TOPRIGHT",3,0)
				end
			end
		end
	else
		self:SetPoint("CENTER",RS.OptionsMain,"CENTER",-50,120)
	end
	RS.RunFunc(self.OnReset)
end
RS.Template.CreateFrameWithBar=function(parent,title,width,height,noborder,nobackground,revers,dragframe)
	--dragger
	local dragger=RS.Template.CreateDragger(parent,dragframe)
	dragger:SetPoint("CENTER",UIParent,"CENTER",0,0)
	--
	local frame=RS.Template.CreateScrollFrame(dragger,1,1,noborder,nobackground,revers)
	frame:HookScript("OnMouseDown",function()
		RS.Template.SwitchCircle(dragger.Circle,1)
		if(dragger.Dragged)then
			(dragframe or dragger):StartMoving()
		else
			RS.OptionsMain:StartMoving()
		end
	end)
	frame:HookScript("OnMouseUp",function()
		RS.Template.SwitchCircle(dragger.Circle,nil)
		if(dragger.Dragged)then
			(dragframe or dragger):StopMovingOrSizing()
		else
			RS.OptionsMain:StopMovingOrSizing()
		end
	end)
	frame.Scroll:HookScript("OnMouseDown",function()
		RS.Template.SwitchCircle(dragger.Circle,1)
		if(dragger.Dragged)then
			(dragframe or dragger):StartMoving()
		else
			RS.OptionsMain:StartMoving()
		end
	end)
	frame.Scroll:HookScript("OnMouseUp",function()
		RS.Template.SwitchCircle(dragger.Circle,nil)
		if(dragger.Dragged)then
			(dragframe or dragger):StopMovingOrSizing()
		else
			RS.OptionsMain:StopMovingOrSizing()
		end
	end)

	frame.Scroll:SetWidth(width)
	frame.Scroll:SetHeight(height)
	frame:SetWidth(width)
	frame:SetHeight(height)
	if(revers)then
		frame.Scroll:SetPoint("TOPRIGHT",dragger,"TOPLEFT",-2,0)
		frame.Scroll.Revers=true
	else
		frame.Scroll:SetPoint("TOPLEFT",dragger,"TOPRIGHT",2,0)
	end
	dragger.Frame=frame
	dragger.Scroll=frame.Scroll
	frame.Scroll.Dragger=dragger
	--RS.Template.SetTooltips=function(text,frame,point,direction,parent)
	RS.Template.SetTooltips(Tooltips["DragToMove"],frame,nil,2,frame.Scroll)
	--title
	local title=RS.Template.CreateText(frame.Scroll,title)
	title:SetPoint("BOTTOM",frame.Scroll,"TOP",0,3)
	frame.Scroll.Title=title
	--sidebar
	local sidebar=CreateFrame("Frame",nil,dragger)
	sidebar:SetPoint("TOP",dragger,"TOP",0,0)
	sidebar:SetWidth(20)
	sidebar:SetHeight(240)
	dragger.SideBar=sidebar
	--
	RS.Template.CreateBackground(sidebar)
	--buttons
	--closer
	local closer=RS.Template.SetCloser(sidebar,dragger,2)
	closer:SetPoint("BOTTOM",sidebar,"BOTTOM",0,0)

	dragger.Closer=closer
	--reseter
	local reseter=CreateFrame("Frame",nil,sidebar)
	reseter:EnableMouse(1)
	reseter:SetScript("OnMouseUp",function()
		RS_Template_FrameWithBar_Reset(dragger)
	end)
	reseter:SetWidth(20)
	reseter:SetHeight(20)
	reseter.Circle=RS.Template.CreateCircle(reseter,9,2)
	reseter.Circle:SetPoint("CENTER",reseter,"CENTER",0,0)
	reseter:SetScript("OnEnter",function(self)
		RS.Template.SwitchCircle(self.Circle,1)
	end)
	reseter:SetScript("OnLeave",function(self)
		RS.Template.SwitchCircle(self.Circle,nil)
	end)
	--
	RS.Template.SetTooltips(Tooltips["ClickThisToReset"],reseter,nil,2)

	reseter:SetPoint("TOP",dragger,"BOTTOM",0,0)
	dragger.Reseter=reseter
	--minimizer
	local minimizer=CreateFrame("Frame",nil,sidebar)
	minimizer:SetHeight(20)
	minimizer:SetWidth(20)
	minimizer:SetPoint("TOP",reseter,"BOTTOM",0,0)
	RS.Template.SetTooltips(Tooltips["ClickToMinimize"],minimizer,nil,2)
	RS.Template.SetAutoFocus(minimizer)
	--
	local texture=minimizer:CreateTexture(nil,"OVERLAY")
	texture:SetPoint("LEFT",minimizer,"LEFT",4,0)
	texture:SetPoint("RIGHT",minimizer,"RIGHT",-4,0)
	texture:SetHeight(8)
	texture:SetTexture("Interface\\Addons\\NPA2_Options\\texture\\Liner")
	texture:Show()
	--
	minimizer:SetScript("OnMouseUp",function()
		if(frame.Scroll.Minimized)then
			RS.Animation.RestoreScroll(frame.Scroll)
			RS.RunFunc(frame.OnRestoreFunc)
		else
			RS.Animation.MinimizeScroll(frame.Scroll)
			RS.RunFunc(frame.OnMinimizeFunc)
		end
	end)
	dragger.Minimizer=minimizer
	--zoom slider
	local zoomslider=RS.Template.CreateSlider(sidebar,0.5,3,0.01,1,3,
		function(self)
			frame.Scroll:SetScale(self.Value)
			RS.RunFunc(dragger.OnScaleFunc,self.Value)
		end)
	zoomslider:SetWidth(20)
	zoomslider:SetPoint("TOP",minimizer,"BOTTOM",0,-2)
	zoomslider:SetPoint("BOTTOM",closer,"TOP",0,2)
	RS.Template.SetTooltips(Tooltips["DragToScale"],zoomslider,nil,2)
	dragger.ZoomSlider=zoomslider
	--scripts
	dragger:HookScript("OnShow",function(self)
		RS_Template_FrameWithBar_Reset(self)
		RS.Animation.RestoreScroll(frame.Scroll)
	end)
	dragger:HookScript("OnHide",function(self)
		RS.UnregisterMinimize(self)
		RS.RunFunc(dragger.OnHideFunc)
	end)
	return dragger
end